#include "sgl.h"
#include "sega_sys.h"

	#define PAD_NUM 13

	static Uint16 pad_asign[] = {
	PER_DGT_KU,
	PER_DGT_KD,
	PER_DGT_KR,
	PER_DGT_KL,
	PER_DGT_TA,
	PER_DGT_TB,
	PER_DGT_TC,
	PER_DGT_ST,
	PER_DGT_TX,
	PER_DGT_TY,
	PER_DGT_TZ,
	PER_DGT_TR,
	PER_DGT_TL,
	};

	PerAnalog * ana_pre;
	Uint16 data;

	extern PDATA pd_torus1;
	extern OBJECT object_torus1;

	int ss_main(void)
	{
	static ANGLE ang[XYZ];
	static FIXED pos[XYZ];

	slInitSystem(TV_320x240,NULL,1);
		slColRAMMode(CRM16_1024);

		ang[X] = ang[Y] = ang[Z] = DEGtoANG(0.0);
		pos[X] = toFIXED( 0.0);
		pos[Y] = toFIXED( 0.0);
		pos[Z] = toFIXED(190.0);

		slPrint("-----------------------------------",slLocate(1,1));
		slPrint("- button x to rotate on x axis     ",slLocate(1,2));
		slPrint("- button y to rotate on y axis     ",slLocate(1,3));
		slPrint("- button z to rotate on z axis     ",slLocate(1,4));
		slPrint("-----------                        ",slLocate(1,1));
		slPrint("- button a to view credits         ",slLocate(1,5));
		slPrint("                                   ",slLocate(1,6));
		slPrint("                                   ",slLocate(1,7));
		slPrint("                                   ",slLocate(1,8));
		slPrint("                                   ",slLocate(1,9));
		slPrint("                                   ",slLocate(1,10));
		slPrint("                                   ",slLocate(1,11));
		slPrint("                                   ",slLocate(1,12));

		while(1)
		{
		slPushMatrix();
		{
			slTranslate(pos[X],pos[Y],pos[Z]);
			slRotX(ang[X]);
			slRotY(ang[Y]);
			slRotZ(ang[Z]);
			slPutPolygon(&pd_torus1);

				if(!Per_Connect1)
				{
					slPrint("no controller found in socket 1    ",slLocate(1,1));
				}
				data = Smpc_Peripheral[0].data;

				if((data & PER_DGT_TX)==0) ang[X] += DEGtoANG(35.0);
				if((data & PER_DGT_TY)==0) ang[Y] += DEGtoANG(35.0);
				if((data & PER_DGT_TZ)==0) ang[Z] += DEGtoANG(35.0);

				if((data & PER_DGT_TL)==0) ang[X] = ang[Y] = ang[Z] += DEGtoANG(15.0);

				if((data & PER_DGT_TA)==0)
				{
					slPrint("- demo made by: israel jacques     ",slLocate(1,1));
					slPrint("-----------------------------------",slLocate(1,2));
					slPrint("- thanks to vbt                    ",slLocate(1,3));
					slPrint("- thanks to antime                 ",slLocate(1,4));
					slPrint("- thanks to vreuzon                ",slLocate(1,5));
					slPrint("- thanks to iceman2k               ",slLocate(1,6));
					slPrint("- thanks to sasuketea              ",slLocate(1,7));
					slPrint("- thanks to #c on dalnet/efnet     ",slLocate(1,8));
					slPrint("- thanks to sega xtreme            ",slLocate(1,9));
					slPrint("- #emuroms|#emuchina|#saturn-isos  ",slLocate(1,10));
					slPrint("-----------------------------------",slLocate(1,11));
					slPrint("- press b to go back               ",slLocate(1,12));
				}

				if((data & PER_DGT_TB)==0)
				{
					slPrint("-----------------------------------",slLocate(1,1));
					slPrint("- button x to rotate on x axis     ",slLocate(1,2));
					slPrint("- button y to rotate on y axis     ",slLocate(1,3));
					slPrint("- button z to rotate on z axis     ",slLocate(1,4));
					slPrint("-----------                        ",slLocate(1,1));
					slPrint("- button a to view credits         ",slLocate(1,5));
					slPrint("                                   ",slLocate(1,6));
					slPrint("                                   ",slLocate(1,7));
					slPrint("                                   ",slLocate(1,8));
					slPrint("                                   ",slLocate(1,9));
					slPrint("                                   ",slLocate(1,10));
					slPrint("                                   ",slLocate(1,11));
					slPrint("                                   ",slLocate(1,12));

					if((data & PER_DGT_TX)==0) ang[X] += DEGtoANG(35.0);
					if((data & PER_DGT_TY)==0) ang[Y] += DEGtoANG(35.0);
					if((data & PER_DGT_TZ)==0) ang[Z] += DEGtoANG(35.0);
				}
			}
		slPopMatrix();
		slSynch();
	}
}